;This file is copyright (c) 1991, 1992 Informant Communications Group and the
;article author. The material here may be used in an application provided
;that this copyright/disclaimer information is kept in the original source
;file. The material presented here is provided "as is" and with no guarantee.
;Informant Communications Group/Paradox Informant assume no responsibility
;for the use or misuse of the material contained within.
;
;Contents        : procedure MainMenu
;Source File     : DROPMENU.SC
;Author          : Jim Schwarz
;
;Informant Issue : July 1991
;
;Description     : Drop down menus in PAL.
;
; Paradox Informant
; 8525 Elk Grove Blvd.
; Suite 126
; Elk Grove, CA  95624-1777
; Phone: (916) 686-6610
; Fax  : (916) 686-8497
; BBS  : (916) 686-4740
;-----------------------------------------------------------------------------

  ; Script to initialize variables and
  ; call main menu procedure

  ; array containing items for the main
  ; (ring-style) menu
  ARRAY Main[5]
  Main[1]="Accounting"
  Main[2]="Administration"
  Main[3]="Sales"
  Main[4]="Maintenance"
  Main[5]="Exit Program"

  ; array containing start column location
  ; of main menu items
  ARRAY Loc[5]
  Loc[1]=2
  Loc[2]=15
  Loc[3]=32
  Loc[4]=40
  Loc[5]=54

  ; initialization of all menu selections
  ; to first menu item (default)
  MItem=1
  Sub2 =1
  Sub21=1

  AutoLib="MenuLib,DrawMenu"

  MainMenu()

  STYLE
  CLEARALL
  CLEAR

  ; End of script


  CREATELIB "MenuLib"

  PROC MainMenu()
    PRIVATE Key,Next
    Next=MItem

    DrawMain()

    WHILE True
      ; highlight current menu choice
      STYLE ATTRIBUTE 48
      @0,Loc[MItem] ??Main[MItem]
      CANVAS ON
      ; wait for user input
      Key=GETCHAR()
      SWITCH
        CASE Key=-75: ;Left
          IF MItem=1
            THEN Next=5
            ELSE Next=MItem-1
          ENDIF
        CASE Key=-77: ;Right
          IF MItem=5
            THEN Next=1
            ELSE Next=MItem+1
          ENDIF
        CASE Key=13:  ;Enter
          SWITCH
            CASE MItem=1:
            CASE MItem=2:
              Sub2()
            CASE MItem=3:
            CASE MItem=4:
            CASE MItem=5:
              QUITLOOP
          ENDSWITCH
        OTHERWISE:
          BEEP
          LOOP
      ENDSWITCH
      CANVAS OFF
      ; change highlight to original color
      STYLE ATTRIBUTE 31
      @0,Loc[MItem] ??Main[MItem]
      MItem=Next
    ENDWHILE
  ENDPROC


  PROC Sub2()
    PRIVATE Choice

    DrawSub2()

    WHILE True
      ; call to GetChoice passes coordinates
      ; (row and column) of upper left window
      ; corner, current menu selection and
      ; max number of menu items
      Choice=GetChoice(2,13,Sub2,4)
      SWITCH
        CASE Choice=1:
          Sub21()
        CASE Choice=2:
        CASE Choice=3:
        CASE Choice=4:
          ; closing first level menu window
          ; does not require use of Remove
          ; Menu procedure
          @2,13 CLEAR EOS
          QUITLOOP
      ENDSWITCH
    ENDWHILE
  ENDPROC


  PROC Sub21()
    PRIVATE Choice

    DrawSub21()

    WHILE True
      Choice=GetChoice(4,31,Sub21,4)
      SWITCH
        CASE Choice=1:
        CASE Choice=2:
          ; call to program procedure requires
          ; saving current menu selection
          Sub21=2
          ; sample call
          CLEAR
          ?? "Hello world!"
          SLEEP 2000
          ; regeneration of menu screen needs
          ; current menu level information
          RedrawMenuScr("21")
        CASE Choice=3:
        CASE Choice=4:
          RemoveMenu(4,31)
          QUITLOOP
      ENDSWITCH
    ENDWHILE
  ENDPROC


  PROC RemoveMenu(r,c)
    CANVAS OFF
    ; clear menu from screen
    @r,c CLEAR EOS
    ; redraw shadow of underlying menu
    PAINTCANVAS FILL CHR(177)
      ATTRIBUTE 112
      r,c,r+6,c+1
    ; redraw border of underlying menu
    PAINTCANVAS FILL CHR(179)
      ATTRIBUTE 31
      r,c,r+5,c
    @r+5,c ??CHR(217)
  ENDPROC


  PROC RedrawMenuScr(CurrMenu)
    PRIVATE Level,i
    Level=LEN(CurrMenu)

    ; the main menu is always redrawn
    DrawMain()

    ; redraw the sequence of menus in the
    ; current menu chain
    FOR i FROM 1 TO Level
      EXECPROC "DrawSub"+SUBSTR(CurrMenu,1,i)
    ENDFOR
  ENDPROC


  PROC GetChoice(r,c,CurrItem,MaxItems)
    PRIVATE Next,Key
    Next=CurrItem

    WHILE True
      ; highlight current menu choice
      PAINTCANVAS
        ATTRIBUTE 48
        r+CurrItem,c+2,r+CurrItem,c+16
      CANVAS ON
      ; wait for user input
      Key=GETCHAR()
      SWITCH
        CASE Key=-72: ;Up
          IF CurrItem=1
            THEN Next=MaxItems
            ELSE Next=Next-1
          ENDIF
        CASE Key=-80: ;Down
          IF Item=MaxItems
            THEN Next=1
            ELSE Next=Next+1
          ENDIF
        CASE Key=13:  ;Enter
          RETURN CurrItem
        OTHERWISE:
          BEEP
          LOOP
      ENDSWITCH
      CANVAS OFF
      ; change highlight to original color
      PAINTCANVAS
        ATTRIBUTE 31
        r+CurrItem,c+2,r+CurrItem,c+16
      CurrItem=Next
    ENDWHILE
  ENDPROC

  WRITELIB "MenuLib" MenuProg,Sub2,Sub21,RemoveMenu,
                     RedrawMenuScr,GetChoice


  CREATELIB "DrawMenu"

  PROC DrawMain()
    PRIVATE MainMenu
    MainMenu="  "+Main[1]+"   "+Main[2]+"   "+Main[3]+
             "   "+Main[4]+"   "+Main[5]

    CANVAS OFF
    CLEARALL
    CLEAR
    CURSOR OFF

    ; display main menu
    STYLE ATTRIBUTE 31
    @0,0 ?? MainMenu+SPACES(80-LEN(MainMenu))
    ; highlight current choice
    STYLE ATTRIBUTE 48
    @0,loc[mitem] ??main[mitem]
  ENDPROC

  PROC DrawSub2()
    CANVAS OFF
    ; draw menu shadow
    PAINTCANVAS FILL CHR(177)
      ATTRIBUTE 112
      3,14,10,32
    ; draw menu window
    STYLE ATTRIBUTE 31
    SETMARGIN 13
    @2,13

    TEXT
  Ŀ
    Personnel      
    Office Admin   
    Reports        
    Exit to Main   
                   
                   
  
    ENDTEXT

    SETMARGIN 0
    ; highlight current menu choice
    PAINTCANVAS
      ATTRIBUTE 48
      2+Sub2,15,2+Sub2,29
  ENDPROC

  PROC DrawSub21()
    CANVAS OFF
    ; draw menu shadow
    PAINTCANVAS FILL CHR(177)
      ATTRIBUTE 112
      5,32,12,50
    ; draw menu window
    STYLE ATTRIBUTE 31
    SETMARGIN 31
    @4,31

    TEXT
  Ŀ
    Review Recs    
    Edit Recs      
    Archive Recs   
    Exit to Admin  
                   
                   
  
    ENDTEXT

    SETMARGIN 0
    ; highlight current menu choice
    PAINTCANVAS
      ATTRIBUTE 48
      4+Sub21,33,4+Sub21,47
  ENDPROC

  WRITELIB "DrawMenu" DrawMain,DrawSub2,DrawSub21

